import java.util.Arrays;
import java.util.List;

@FunctionalInterface
interface Formatter
{
   String format(String fmtString, Object... arguments);
}

public class MethodRefDemo
{
   public static void main(String[] args)
   {
      List<String> names = Arrays.asList("Charlie Brown",
                                         "Snoopy",
                                         "Lucy",
                                         "Linus",
                                         "Woodstock");
      forEach(names, String::format);
      forEach(names, (fmt, arg) -> String.format(fmt, arg));
   }

   public static void forEach(List<String> list, Formatter formatter)
   {
      for (String item: list)
         System.out.print(formatter.format("%s%n", item));
      System.out.println();
   }
}